{{- if and (.Values.ingressNginx) (.Values.ingressNginx.enable) -}}
apiVersion: argoproj.io/v1alpha1
kind: Application
metadata:
  name: ingress-nginx
  namespace: {{ .Values.argoNamespace | default "argocd" }}
  finalizers:
  - resources-finalizer.argocd.argoproj.io
  annotations:
    argocd.argoproj.io/sync-wave: "2"
spec:
  project: {{ .Values.argoProject | default "default" }}
  source:
    repoURL: {{ .Values.repoUrl }}
    path: add-ons/ingress-nginx
    targetRevision: {{ .Values.targetRevision }}
    helm:
      valueFiles:
      - values.yaml
      #- values-{{ .Values.environment }}.yaml #if adding environment specific variables
      values: |
        ingress-nginx:
        {{- toYaml .Values.ingressNginx | nindent 10 }}
          controller:
            service:
              annotations:
                service.beta.kubernetes.io/aws-load-balancer-name: {{ .Values.clusterName }}-ing-nginx
                external-dns.alpha.kubernetes.io/hostname: {{ .Values.clusterName }}-ing.{{ .Values.domain_name_suffix }}
  destination:
    server: {{ .Values.destinationServer | default "https://kubernetes.default.svc" }}
    namespace: ingress-nginx
  syncPolicy:
    automated:
      prune: true
    syncOptions:
      - CreateNamespace={{ .Values.ingressNginx.createNamespace }}
      - ServerSideApply=true
    retry:
      limit: 1
      backoff:
        duration: 5s
        factor: 2
        maxDuration: 1m
{{- end -}}
